#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
#include <Servo.h> 

int r3 = 13;//Search load SENSOR define r3
int r2 = 12;//Search load SENSOR define r2
int r1 = 11;//Search load SENSOR define r1
int l1 = 10;//Search load SENSOR define l1
int l2 = 9;//Search load SENSOR define l2
int l3 = 8;//Search load SENSOR define l3

int E1 = 5;     //M1 Speed Control
int E2 = 6;     //M2 Speed Control
int M1 = 4;     //M1 Direction Control
int M2 = 7;     //M1 Direction Control

float Searchpoint[6]={0};                                 //define a table to save the data by nfrared routing sensor
float Setpoint=0,Input,Outputtemp;                        //define the parameter of PID :Setpoint Input,Output
int LastInput=0,LastTime=0,countmp3=0,lastcountmp3time=0; //define the count which to control the  timer(the MP3 part);
int countrgb=0,lastcountrgbtime=0,changesong=0;           //define the count which to control the  timer(the RGB part);
double ITerm=0;                                           //the variable of integration of PID;
int Maxspeed=0;                                           //to limit the max speed for car;
int Noone=0,Notwo=0;                                      //change the song

Servo myservo2; 
Servo myservo1;

void cardriver(int a,int b)                               //the function of driver
{
  analogWrite (E1,a);
  digitalWrite(M1,0);
  analogWrite (E2,b);
  digitalWrite(M2,0);
}

void In_it()                                              //the nfrared routing sensor initialization
{
  Searchpoint[0]=(1-digitalRead(l3))*2.4;
  Searchpoint[1]=(1-digitalRead(l2))*1.8;
  Searchpoint[2]=(1-digitalRead(l1))*1;
  Searchpoint[3]=(1-digitalRead(r1))*1;
  Searchpoint[4]=(1-digitalRead(r2))*1.8;
  Searchpoint[5]=(1-digitalRead(r3))*2.4;
}

float MaxThree(float a,float b,float c)                    //decide the max number of three number
{
  float temp=0,temp2=0;
  if(a>b)temp=a;
  else temp=b;
  if(a>c)temp2=a;
  else temp2=c;
  if(temp>temp2)temp=temp;
  else temp=temp2;
  return temp;
}

void SwitchMaxspeed(float a)                              //limit the max speed for car 
{
  int b=a*10;
  switch(b)
  {
    case 0:      {Maxspeed=44;ITerm=0;}      break;
    case 10:       Maxspeed=44;      break;
    case -10:      Maxspeed=44;      break;
    case 18:       Maxspeed=65;      break;
    case -18:      Maxspeed=65;      break;
    case 24:       Maxspeed=110;      break;
    case -24:      Maxspeed=110;      break;
    default:     {Maxspeed=44;ITerm=0;}      break;
  }
}

float Decide_input(float table[])                        //decide the status of nfrared routing sensor
{
  float templ=0,tempr=0;
  float a=table[0],b=table[1],c=table[2],d=table[3],e=table[4],f=table[5];

  templ=MaxThree(a,b,c);
  tempr=MaxThree(d,e,f)*(-1); 

  if(abs(templ)>abs(tempr)){SwitchMaxspeed(templ);return templ;}
  else if(abs(templ)==abs(tempr)){SwitchMaxspeed(0);return 0;}
  else {SwitchMaxspeed(tempr); return tempr;}
}


void PID_speed(int a)                                     //PID
{
  float error=0;
  unsigned long now = millis();
  unsigned long timeChange = (now - LastTime);
  if(timeChange>=1)
  {
    error = Setpoint- Input;
    ITerm=ITerm+0.01 * error;
    
    if(ITerm>a)ITerm=a;
    else if(ITerm<-a)ITerm=-a;
    
    double dInput=(Input-LastInput);
    Outputtemp = 10 * error + ITerm-dInput*11;
    
    if(Outputtemp>a)Outputtemp=a;
    else if(Outputtemp<-a)Outputtemp=-a;
    else Outputtemp=Outputtemp;
    
    LastInput=Input;
    LastTime=now;
  }
}

void Distance_stop()                               //detect the  obstacle,then to stop and singing
{
    while(analogRead(A0)>400 )
     {
        cardriver(0,0);
          myservo1.write(90);//180-90
          myservo2.write(90);
         mp3_play (3);
         for(int i=0;i<35;i++){
         analogWrite(A5,random(255));
         analogWrite(A4,random(255));
         analogWrite(A3,random(255));
         delay(100);} 
        mp3_stop(); 
        countmp3=0;         
       }
     while(analogRead(A1)>400 );  
}

void RGB_playgrand( )                      //RGB functiong
{
  int countrgbtime=millis();
  int countrgbtimechange=countrgbtime-lastcountrgbtime;
  if(countrgbtimechange>=500)
  {
    analogWrite(A5,random(255));
    analogWrite(A4,random(255));
    analogWrite(A3,random(255));
    countrgb++;
    lastcountrgbtime=countrgbtime;
  }
  if(countrgb>2)countrgb=0;
}

void mp3_playground()                      //MP3 funtiong
{
  if(analogRead(A0)>300||analogRead(A2)>300)changesong=1;
  if(analogRead(A1)>300)countmp3=0; 
  switch(changesong)
  {
    case 0:
      {Noone=1;Notwo=4;}
    break;
    case 1:
      {Noone=2;Notwo=6;}
    break;
    default:
    break;
  }
  
  int countmp3time=millis();
  int countmp3timechange=countmp3time-lastcountmp3time;
  
  if(countmp3timechange>=1000)
  {
    countmp3++;
    if(countmp3==Noone)mp3_play (Noone);
    else if(countmp3==Notwo)mp3_stop ();
    lastcountmp3time=countmp3time;
  }
  if(countmp3==6)changesong=0;
  if(countmp3>=Notwo)countmp3=0;
}

void setup(){        
  //Serial.begin(9600); 
  for(int i=8;i<14;i++)pinMode(i,INPUT);
  for(int i=4;i<=7;i++) pinMode(i, OUTPUT); 
  digitalWrite(E1,LOW);   
  digitalWrite(E2,LOW);
  pinMode(A5,OUTPUT);
  pinMode(A4,OUTPUT);
  pinMode(A3,OUTPUT);
  pinMode(A0,INPUT);
  Serial1.begin (9600);
  mp3_set_serial (Serial1);	//set Serial for DFPlayer-mini mp3 module 
  mp3_set_volume (25);
  myservo1.attach(3);  // attaches the servo on pin 9 to the servo object 
  myservo2.attach(2);
}

void loop()
{
      myservo1.write(180);//180-90      
      myservo2.write(0);//0-90
      RGB_playgrand();                               //show the RGB
      mp3_playground();                              //show the mp3
      In_it();                                       //initialization
      Input=Decide_input(Searchpoint);               //Input the data
      PID_speed(Maxspeed);                           //PID
      cardriver(60+Outputtemp,60-Outputtemp);        //driver
      if(analogRead(A0)>400)
      {
        analogWrite(A5,0);
        analogWrite(A4,0);
        analogWrite(A3,0);
        myservo1.write(90);//180-90
        myservo2.write(90);//0-90
        
        while(analogRead(A0)>400)cardriver(0,0);
      }
      Distance_stop();
     
}



